# 7.3 난수(준비1)
runif(1)                     # 난수를 한 개 생성 
runif(10)                    # 난수를 열 개 생성 
runif(1)                     # 난수를 한 개 생성 

coin <- function() {
  x <- runif(1)
  if   (x <= 1/2) men <- 1   # 1 : 앞 
  else            men <- 0   # 0 : 뒤  
  return(men)
}
coin()                       # 동전을 1회 던진다 

zyanken <- function() {
  x <- runif(1)
  if      (x <= 1/3) te <- 1 # 1 : 가위 
  else if (x <= 2/3) te <- 2 # 2 : 바위 
  else               te <- 3 # 3 : 보 
  return(te)
}
zyanken()                    # 가위바위보를 한다 


# 7.4 1회 시뮬레이션(준비2)
mycointoss <- function(n) {
  count <- 0
  for (i in 1:n) {
    x <- runif(1)
    # 동전 던지기 결과를 결정(앞:1, 뒤:0)
    if (x <= 1/2) coin <- 1
    else          coin <- 0
    # 동전 던지기 결과가 1이면 카운트 
    if (coin == 1) count <- count + 1
  }
  return(count)
}
mycointoss(10)                      # 동전을 10회 던지면...

mycointoss <- function(n) {
  count <- 0
  for (i in 1:n) {
    x <- coin()                     # 동전을 던지고 
    if (x == 1) count <- count + 1  # 앞면이면 카운트한다 
  }
  return(count)
}

mycointoss <- function(n) {
  count <- 0
  for (i in 1:n) {
    count <- count + coin()         # 앞(1)이나 뒤(0)를 카운트한다 
  }
  return(count)
}



# 7.5 몬테카를로 시뮬레이션 
mymontecarlo <- function(n) {
  count <- 0                        # 카운트를 0으로 되돌린다 
  for (i in 1:n) {
    count <- count + coin()         # 동전 던지기를 n회 반복 
  }
  return(count / n)                 # 결과를 출력 
}
mymontecarlo(10000)

coin.montecarlo <- function(n) {
  count <- 0                        # 카운터를 0으로 되돌린다 
  for (i in 1:n) {
    count <- count + mycointoss(10) # 10회 동전 던지기 
  }
  return(count / n)                 # 결과를 출력 
}
coin.montecarlo(1000)               # 10회 동전 던지기를 1000회 
coin.montecarlo(10000)              # 10회 동전 던지기를 1000회 
coin.montecarlo(100000)             # 10회 동전 던지기를 10000회 

pi.montecarlo <- function(n) {
  count <- 0                                # 카운터를 0으로 
  for (i in 1:n) {
    suna <- runif(2)                        # 변수 suna는  
    if (sqrt(suna[1]^2 + suna[2]^2) < 1) {  # (x좌표, y좌표)
      count <- count + 1                    # 인 벡터가 
    }                                       # 되어 있다 
  }
  return(4 * count / n)                     # 파이를 구한다 
}
pi.montecarlo(10000)

pi.montecarlo2 <- function(n) {
  count <- 0                                # 카운터를 0으로 
  for (i in 1:n) {
    suna <- runif(2, min=-1, max=1)         # 변수 suna는 
    if (sqrt(suna[1]^2 + suna[2]^2) < 1) {  # (x좌표, y좌표)
      count <- count + 1                    # 인 벡터가 
    }                                       # 되어 있다
  }
  return(4 * count / n)                     # 파이를 구한다 
}
pi.montecarlo2(10000)



# 7.6 팁 
myball <- function(n) {
  count <- 0
  for (i in 1:n) {
    u <- runif(3)   # u = ( x좌표, y좌표, z좌표)
    pt <- (u[1]-0.3)^2 + (u[2]-0.3)^2 + (u[3]-0.7)^2
    if (pt < 0.3^2) count <- count + 1
    else {
      pt <- (u[1]-0.5)^2 + (u[2]-0.5)^2 + (u[3]-0.5)^2
      if (pt < 0.4^2) count <- count + 1
      else {
        pt <- (u[1]-0.7)^2 + (u[2]-0.7)^2 + (u[3]-0.7)^2
        if (pt < 0.3^2) count <- count + 1
      }
    }
  }
  return(count/n)
}
myball(10000)

mymontecarlo2 <- function(n, k, fun) {
  count <- 0
  for (i in 1:n) {
    count <- count + fun(k)
  }
  return(count/n)
}
mymontecarlo2(10000, 10, mycointoss)

rbinom(1, 1, 0.5)          #  1회 동전 던지기 
sum(rbinom(10, 1, 0.5))    # 10회 동전 던지기 
mymontecarlo2(100000, 1, runif)
mymontecarlo2(100000, 1, rexp)
mymontecarlo2(100000, 1, rnorm)
