# 8.2 고수준작도함수 y <- c(1,1,2,2,3,3,4,4,5,5)     # (1) 데이터를 준비한다 
plot(y)                          # (2) 그래프를 그린다(범위는 자동으로 정해진다)
x <- 1:10                        # (1) x축 데이터를 준비한다 
y <- 1:10                        # (1) y축 데이터를 준비한다 
plot(x, y)                       # (2) 그래프를 그린다(범위는 자동으로 정해진다)

plot(sin,  -pi, 2*pi)            # (2) 정현함수를 플롯한다 
curve(sin, -pi, 2*pi)            # (2) 함수 curve() ： 위와 같은 그래프 

gauss.density <- function(x) {   # (1) 표준정규분포의 밀도함수를 정의한다 
  1/sqrt(2*pi)*exp(-x^2/2)       # 
}                                # 
plot(gauss.density, -3, 3)       # (2) 표준정규분포를 플롯한다 
curve(gauss.density,-3, 3)       # (2) 함수 curve() : 위와 같은 그래프 

x <- 1:10                        # (1) x축 데이터를 준비한다 
y <- 1:10                        # (1) y축 데이터를 준비한다  
plot(x, y, xlim=c(0,11))         # (2) 그래프를 그린다(범위를 xlim으로 정한다)
plot(x, y, xlim=c(11,0))         # (2) 그래프를 그린다(범위를 xlim으로 정한다)
y <- c(1, 3, 2, 4, 8, 5, 7, 6, 9)
plot(y, main="Simple Time Series")
y <- c(1, 3, 2, 4, 8, 5, 7, 6, 9)
plot(y, ylim=c(0, 10), type = "l")
plot(5:9, ylim=c(0, 10), type = "p", ylab=""); par(new=T)
plot(4:8, ylim=c(0, 10), type = "l", ylab=""); par(new=T)
plot(3:7, ylim=c(0, 10), type = "b", ylab=""); par(new=T)
plot(2:6, ylim=c(0, 10), type = "c", ylab=""); par(new=T)
plot(1:5, ylim=c(0, 10), type = "o", ylab="")
legend(4, 2.5, paste("type =", c("p","l","b","c","o"), "   "))
x <- runif(100)
y <- runif(100)
plot(x, y, pch = ifelse(y>0.5, 1, 18))



# 8.3 저수준 적도함수와 그래프 중첩 
plot(1:10)                                    # 산포도를 그린다­
abline(h=5)                                   # 직선 : y = 5를 추가한다 
rect(1,6, 4,9)                                # 좌측상단에 사각형을 추가한다 
rrows(1,1, 4,4)                               # 죄측하단에 화살표 추가한다  
text(8,9,"ABCD")                              # 우측상단에 문자를 추가한다 
title("main","sub")                           # 표제와 부제목을 추가한다 
legend(8,3,lty=1:3,
  c("P","Q","R"))                             # 우측하단에 범례를 추가한다 

plot(sin, -pi, pi, xlab="", ylab="", lty=2)   # sin(x)를 그린다 
par(new=T)                                    # 겹쳐 그리기 지정 
plot(cos, -pi, pi, xlab="x", ylab="y")        # cos(x)를 겹쳐 그린다 
plot(sin, -pi, pi, xlab="x", ylab="y", lty=2) # 새롭게 그래프를 그린다 
plot(cos, -pi, pi, add=T)                     # cos(x)를 겹쳐 그린다 
F <- function(x, a) { 1/(1+exp(-a-x)) }       # 작도하는 함수 
curve(F(x,-1), col=1)
par(new=T)                                    # 앞의 그래프를 남겨둔 채로 다음 그래프를 그린다
curve(F(x, 1), col=2)

curve(F(x,-1), col=1, xlim=c(-5,5), ylim=c(0,1))
par(new=T)
curve(F(x, 1), col=2, xlim=c(-5,5), ylim=c(0,1))

curve(F(x,-1), col=1, xlim=c(-5,5),  ylim=c(0,1), ylab="")
par(new=T)
curve(F(x, 1), col=2, xlim=c(-5,5),  ylim=c(0,1), ylab="F(x)")

curve(F(x,-1), col=1, xlim=c(-5,5),  ylim=c(0,1), ylab="")
par(new=T)
curve(F(x, 1), col=2, xlim=c(-5,5),  ylim=c(0,1), ylab="F(x)")
legend(3, 0.4, c("a = -1","a =  1"), lty=1, col=1:2)



# 8.4 그래프 저장 
setwd("c:/usr")                     # 작업 디렉터리 지정 
getwd()                             # 현재 작업 디렉터리를 표시 

png(filename = "filename.png", width = 480, height = 480,
    pointsize = 12, bg = "white")

pdf(file="filename.pdf")            # pdf 장치를 연다 
plot(1:10)                          # 플롯한다 
dev.off()                           # 장치를 닫는다 

postscript(file="filename.eps", horizontal = FALSE, onefile = FALSE, 
           paper="special" , height=9, width=14)
plot(1:10)                          # 플롯한다 
dev.off()                           # 장치를 닫는다 

plot(1:10)                          # 그래프를 그린 다음 
dev.copy(pdf, "filename.pdf")       # pdf로 저장한다 
dev.copy2eps(file="finename.eps")   # eps로 저장한다 
dev.off()                           # 파일을 닫는다 

pdf(file="c:/filename.pdf")         # pdf 장치를 연다 
plot(1:10)                          # 플롯한다 
dev.off()                           # 장치를 닫는다 



# 8.5 팁 
frame()
plot.new()  
x <- 0:10
plot(x, dbinom(x,10,0.5), type="h", lwd=5)
curve(dnorm, -4, 4, type="l") # 플롯 
xvals <- seq(2, 4, length=10) # 그림자를 추가 
dvals <- dnorm(xvals)
polygon(c(xvals,rev(xvals)), c(rep(0,10),rev(dvals)),col="gray")

x <- seq(-3, 3, length= 61)         # x축 방향의 분점 
y <- x                              # y축 방향의 분점 
f <- function(x, y) {               # 2차원 정규분포 함수 
  return( 1/(2*pi)*exp(-(x^2+y^2)/2) )
}
z <- outer(x, y, f)                 # z방향의 크기를 구한다 
persp(x, y, z, theta=30, phi=30, expand=0.5, col="lightblue")

options(repos="http://cran.md.tsukuba.ac.jp")
install.packages("rgl")
library(rgl)
example(rgl.surface)
for(i in 1:360) rgl.viewpoint(i,i/4)
clear3d()                           # 도형을 제거 
clear3d(type="lights")              # 광원 설정을 제거 
clear3d(type="all")                 # bounding-box 설정 제거 
x <- rnorm(100)                     # x축 데이터 준비 
y <- rnorm(100)*2                   # y축 데이터 준비 
z <- rnorm(100)*3                   # z축 데이터 준비 
plot3d(x, y, z)                     # 3차원 산포도 그리기 
x <- seq(-10, 10, length= 51)
y <- x
f <- function(x,y) { r <- sqrt(x^2+y^2); 10 * sin(r)/r }
z <- outer(x, y, f)
persp3d(x, y, z, aspect=c(1, 1, 0.5), col="lightblue",
        xlab="X", ylab="Y", zlab="")
snapshot3d("filename.png")
rgl.postscript("filename.pdf", "pdf", drawText=FALSE)
