# 9.2 데이터를 R로 읽어들인다 
flour <- c( 3, -2, -1,  0,  1, -2)  # 밀가루 사용 
diet  <- c(-4,  1, -3, -5, -2, -8)  # 다이어트약 사용 
total <- c(flour, diet)             # 12명의 데이터 



# 9.3 데이터를 플롯한다 
hist(total)
plot(density(flour), xlim=c(-8,8), ylim=c(0,0.2), lty=1, ann=F)
par(new=T)
plot(density(diet),  xlim=c(-8,8), ylim=c(0,0.2), lty=2)
legend(4, 0.2, c("flour","diet"), lty=1:2, ncol=1)   # 범례를 그린다 
boxplot(flour, diet, names=c("flour", "diet"))



# 9.4 데이터의 통계량을 구한다 
sum(total)
quantile(total, prob=0.8, name=F) # 아래에서 확률 0.8인 위치의 데이터 
fivenum(total)                    # min, 1Q, median, 3Q, max
sum( (total-mean(total))^2 )      # 평항합 
variance <- function(x) var(x)*(length(x)-1)/length(x)
variance(total)                   # 표본분산 
var(total)                        # 불편분산 
sd(total)                         # 표준편차 = sqrt(var(total))
var(flour, diet)                  # 불편공분산행렬 
cor(flour, diet)                  # 상관계수 



# 9.5 검정결과 보는 법 
t.test(diet, mu=0)
t.test(diet, mu=0, alternative="greater")
t.test(flour, diet, var.equal=T)



# 9.6 직선회귀 최소제곱법 
height <- c(177,165,175,168,171,168,190,167,173,172,171,177)
weight <- c( 62, 65, 75, 58, 59, 66, 74, 61, 70, 80, 71, 68)
plot(weight, height)
result <- lm(height ~ weight)     # 단회귀분석 
abline(result)
result <- lm(height ~ weight)     # 단회귀분석 
summary(result)                   # 분석결과 요약 

new <- data.frame(weight = 68)
predict(result, new, interval="confidence", level=0.95)
predict(result, new, interval="predict", level=0.95)

new <- data.frame(weight = seq(55, 80, 1))
result.pre <- predict(result, new, interval="prediction")
result.con <- predict(result, new, interval="confidence")
matplot(new$weight, cbind(result.pre, result.con), type="l")



# 9.7 팁 
var.test(flour, diet)

my.cor <- function(x) {
  tmpcor <- cor(x)
  if (det(tmpcor) != 0)  sol <- solve(tmpcor)
  else { library(MASS);  sol <- ginv(tmpcor) }
  d <- diag(sol)
  sol <- -sol/sqrt(outer(d,d))
  rownames(sol) <- paste("Var", 1:ncol(x))
  colnames(sol) <- paste("Var", 1:ncol(x))
  return(sol)
}
x <- matrix(c(1:9), ncol=3, byrow=T)
my.cor(x)

height <- c(177,165,175,168,171,168,190,167,173,172,171,177)
scale(height)
